Python / 12 Python 中的异常处理

Python 中的异常处理

程序读文件内容的过程可能会发生错误,例如:要读取的文件不存在。传统的错误处理方式如下:

  • 某个函数 f 在运行过程中可能会发生错误;
  • 函数 f 发生错误时,函数 f 返回错误代码;
  • 在调用函数 f 的地方,需要检查 f 的返回值是否有错。

1. 传统的错误处理方式

1.1 返回错误码

例如,在 C 语言中,函数 open 用于打开一个文件,它的声明如下:

int open(char *path, int mode);
  • 参数 path 指定要打开的文件;
  • 参数 mode 指定打开文件的方式:只读、读写;
  • 函数返回一个整数,该整数作为文件的标识符;
    • 如果打开文件成功,则返回一个非负的整数;
    • 如果打开文件失败,则返回 -1。

因此,通过检查函数 open 的返回值,即可以判断 open 是否成功,示例如下:

int file = open("test.txt", O_RDONLY);
if (file < 0)
    puts("open file failed");
    ...
  • 在第 1 行,函数 open 打开文件 test.txt
  • 在第 2 行,如果函数 open 的返回值小于 0,则表示打开文件失败

1.2 缺点

通过错误代码的方式很容易理解,但是存在一个严重的问题:用户可能忘记了错误检查。例如:

int file = open("test.txt", O_RDONLY);
char buf[1024];
read(file, buf, sizeof(buf));
对 buf 中的数据进行处理;
close(file);
  • 在第 1 行,使用 open 打开文件;
    • 在此处忘记对 open 的返回值进行检查
    • 如果文件 test.txt 不存在,则 open 返回 -1,此时 file 为 -1;
  • 在第 3 行,使用 read 读取文件 file,将内容读取到 buf 中;
    • open 的操作失败了,此时 file 为 -1;
    • read 的第一个参数 file 是一个无效的文件标识符;
    • read 的操作必然也是失败的;
  • 在第 4 行,对 buf 中的数据进行处理;
    • open 操作和 open 操作都发生了错误;
    • buf 中的数据是无效数据。

在整个过程中,发生了两次错误:open 文件失败、read 文件失败,但是用户没有得到任何提醒。buf 中的数据是无效的,对读取的数据进行操作是无效的。

2. 异常的处理方式

Python 程序的执行过程中,当发生错误时会引起一个事件,该事件被称为异常。异常会打断程序的正常执行流程,例如,编写程序 control-flow.py

print('AAA')
100 / 0
print('BBB') # 此行代码不会被执行
  • 在第 1 行,打印 AAA;
  • 在第 2 行,100 除以 0;
    • 除数是 0,Python 无法执行该条语句,Python 产生一个异常事件通知用户;
  • 在第 3 行,打印 BBB。

程序运行的结果如下:

AAA
Traceback (most recent call last):
  File "control-flow.py", line 2, in <module>
    100 / 0
ZeroDivisionError: division by zero
  • 在第 1 行,程序输出 AAA;
  • 在第 3 行,指明了产生异常的位置:File “control-flow.py”, line 2
    • 在文件 “control-flow.py” 的第 2 行,产生了异常;
    • 这行信息非常重要,用于排查错误;
  • 在第 5 行,指明了异常的类型 ZeroDivisionError: division by zero
    • 程序的执行流程被打断了,程序不再执行发生异常之后的代码;
    • 当发生异常时需要捕获处理它,否则程序会中止执行。

1.3 读取文件

编写一个读取文件内容的 Python 程序,如果不进行错误处理,代码如下:

file = open('test.txt')
line = file.readline()
print(line)
file.close()
  • 在第 1 行,打开文件 test.txt;
  • 在第 2 行,读取文件的一行;
  • 在第 3 行,打印;
  • 在第 4 行,关闭文件。

在下面的小节中,将使用异常处理对这个程序逐步进行改进。

2. try … except 语句

2.1 基本用法

Python 处理异常的基本语法如下:

try:
	可能发生异常的代码块
except:
	处理异常的代码块	
  • 在 try 关键字后,是可能发生异常的代码块;
    • 当发生异常后,程序跳转到处理异常的代码块;
  • 在 except 关键字后,是处理异常的代码块。

下面的程序首先抛出异常,然后捕获该异常,代码如下:

try:
    print('try:')
    100/0
    print('never reach here')
except:    
    print('except:')
  • 在第 2 行,打印字符串 ‘try:’;
  • 在第 3 行,执行 100/0,除数是 0,会抛出异常;
  • 在第 4 行,抛出异常后,程序跳转到处理异常的代码块,该行代码不会被执行;
  • 在第 6 行,捕获异常后,打印字符串 ‘except:’。

程序运行输出:

try:
except:

2.2 处理指定类型的异常

在 except 关键字后加上异常类型,表示仅处理该类型的异常,语法如下:

try:
	可能发生异常的代码块
except 异常类型:
	处理异常的代码块	

下面的程序仅处理 ZeroDivisionError 类型的异常:

try:
    print('try:')
    100/0
    print('never reach here')
except ZeroDivisionError:
    print('except ZeroDivisionError:')
  • 在第 2 行,打印字符串 ‘try:’;
  • 在第 3 行,执行 100/0,除数是 0,会抛出 ZeroDivisionError 类型的异常;
  • 在第 4 行,抛出异常后,程序跳转到处理异常的代码块,该行代码不会被执行;
  • 在第 5 行,程序仅仅捕获 ZeroDivisionError 类型的异常;
  • 在第 6 行,捕获异常后,打印字符串 ‘except ZeroDivisionError:’。

程序运行输出:

2.3 处理多种类型的异常

可以使用多个 except 关键字处理多种类型的异常,语法如下:

try:
	可能发生异常的代码块
except 异常类型1:
	处理异常的代码块	
except 异常类型2:
	处理异常的代码块	
...		

编写一个能够捕获两种类型的异常的程序,首先编写函数 generateError。函数 generateError 在运行时,可能抛出两种类型的异常,代码如下:

def generateError():
    import random
    number = random.randint(0, 1)
    if number == 0:
        100 / 0
    else:
        file = open('none-exsist-file')
  • 在第 3 行,产生一个 [0, 1] 之间的随机数
  • 在第 4 行,如果随机数是 0
    • 在第 5 行,被除数是 0,产生 ZeroDivisionError 类型的异常
  • 在第 6 行,如果随机数是 1
    • 在第 7 行,打开一个不存在的文件,产生 IOError 类型的异常

编写捕获两种类型异常的程序:

try:
    print('try:')
    generateError()
    print('never reach here')
except ZeroDivisionError:
    print('except ZeroDivisionError:')
except IOError:    
    print('except IOError:')
  • 在第 3 行,调用 generateError(),会随机抛出 ZeroDivisionError 类型或者 IOError 类型的异常;
  • 在第 5 行,程序捕获 ZeroDivisionError 类型的异常;
    • 在第 6 行,捕获异常后,打印字符串 ‘except ZeroDivisionError:’;
  • 在第 7 行,程序捕获 IOError 类型的异常;
    • 在第 8 行,捕获异常后,打印字符串 ‘except IOError:’。

2.4 except … as

在捕获异常时,不仅可以获取异常类型,还可以获取异常对象,语法如下:

except 异常类型 as 异常对象:

下面的例子处理异常时,同时获取了异常类型和异常对象:

try:
	list = ['www', 'imooc', 'com']
	print(list[3])
except Exception as e:
	print('except: %s' % e)
  • 在第 4 行,异常类型为 Exception,异常对象为 e
  • 在第 5 行,打印异常对象 e

程序输出如下:

except: list index out of range

2.5 读取文件

下面的程序实现 1.3 小节读取文件的功能需求:

try:
    file = open('test.txt')
    line = file.readline()
    print(line)
    file.close()
except IOError:    
    print('except IOError:')
  • 在第 2 行,调用 open 函数可能会产生 IOError;
  • 在第 3 行,调用 readline 函数可能会产生 IOError;
  • 在第 5 行,关闭文件;
    • 当异常发生时,该行代码不会被执行
  • 在第 6 行,捕获 IOError 类型的异常。

这个版本的程序的缺陷在于,当异常发生时,关闭文件的代码不会被执行。文件打开后,没有及时关闭,会带来潜在的问题。在下面的小节中,将对这个程序进行改进。

3. try … else 语句

3.1 基本用法

在异常处理中 else 关键字用于指定没有异常时执行的代码块,语法如下:

try:
	可能发生异常的代码块
except:
	处理异常的代码块
else:
    没有异常时执行的代码块
  • 当发生异常时,执行 except 对应的代码块
  • 当没有发生异常时,执行 else 对应的代码块

3.2 读取文件

下面的程序实现 1.3 小节读取文件的功能需求:

try:
    file = open('test.txt')
    line = file.readline()
except IOError:    
    print('except IOError:')
else:
    print(line)
    file.close()    
  • 在第 2 行,调用 open 函数可能会产生 IOError;
  • 在第 3 行,调用 readline 函数可能会产生 IOError;
  • 在第 5 行,关闭文件;
    • 当异常发生时,该行代码不会被执行
  • 在第 6 行,else 关键字定义了没有异常时执行的代码;
    • 在第 7 行,打印文件内容;
    • 在第 8 行,关闭文件。

这个版本的程序的仍然存在缺陷,当异常发生时,关闭文件的代码不会被执行。文件打开后,没有及时关闭,会带来潜在的问题。在下面的小节中,将对这个程序进行改进。

4. try … finally 语句

4.1 基本用法

在异常处理中,finally 关键字用于指定无论是否发生异常都需要执行的代码块,语法如下:

try:
	可能发生异常的代码块
except:
	处理异常的代码块
finally:
    无论是否发生异常都会执行的代码块

下面的程序在执行过程中没有异常:

try:
    print('try:')
finally:    
    print('finally:')

程序输出:

try:
finally:

下面的程序在执行过程中产生异常:

try:
    print('try:')
    100 / 0
finally:    
    print('finally:')

程序输出:

try:
finally:

可以看出,无论是否发生异常,finally 定义的代码块总是被执行

4.2 读取文件

下面的程序实现 1.3 小节读取文件的功能需求:

try:
    file = open('test.txt')
  	line = file.readline()
   	print(line)
except IOError:
    print('except IOError:')
finally:
	if file:
  		file.close()
  • 在第 2 行,调用 open 函数可能会产生 IOError;
    • 如果在此处产生 IOError,变量 file 的值为空
  • 在第 3 行,调用 readline 函数可能会产生 IOError;
    • 如果在此处产生 IOError,因为已经成功打开了文件,变量 file 的值不为空;
  • 在第 5 行,捕获 IOError 类型的异常;
  • 在第 7 行,finally 关键字定义了最终需要执行的代码块;
    • 发生异常时,会执行该代码块;
    • 没有异常时,也会执行该代码块;
  • 在第 8 行,检查变量 file 的值是否为空;
    • 如果程序在 open 的地方发生异常,变量 file 的值为空,不需要关闭文件;
    • 如果程序在 readline 的地方发生异常,变量 file 的值不为空,需要关闭文件。

5. raise 语句

Python 提供了 raise 语句用于抛出异常,raise 语句有 3 种形式:

形式 功能
raise 不带任何参数
raise Exception 把异常的名称作为参数
raise Exception(info) 把异常的名称、异常的描述信息作为参数

5.1 raise

try:
	print('try:')
	raise
	print('never reach here')
except:
	print('except:')
  • 在第 3 行,使用 raise 抛出异常;
  • 在第 4 行,不会执行这行代码,执行 raise 后,程序流程跳转到第 5 行;
  • 在第 5 行,捕获程序抛出的异常。

程序输出如下:

try:
except:

5.2 raise Exception

try:
	print('try:')
	raise ValueError
	print('never reach here')
except ValueError:
	print('except ValueError:')
  • 在第 3 行,使用 raise 抛出特定类型的异常 ValueError;
  • 在第 4 行,不会执行这行代码,执行 raise 后,程序流程跳转到第 5 行;
  • 在第 5 行,捕获程序抛出的 ValueError 类型的异常。

程序输出如下:

try:
except ValuseError:

5.3 raise Exception(info)

编写程序 raise.py 如下:

try:
	text = input('Please input digit: ')
	if not text.isdigit():
		info = '"%s" is not digit' % text
		raise ValueError(info)
except ValueError as e:
	print('except ValueError: %s' % e)	
  • 在第 2 行,提示用户输入数字;
  • 在第 3 行,如果用户输入的不是数字;
    • 在第 4 行,拼接字符串 info 用于描述错误的具体信息
    • 在第 5 行,ValueError(info) 创建了一个对象,包括:异常类型和错误信息,使用 raise 抛出该异常对象;
  • 在第 6 行,捕获程序抛出的 ValueError 类型的异常,变量 e 指向 raise 语句抛出的异常。

程序输出如下:

C:\> python raise.py
Please input digit: abc
try:
except ValuseError: abc is not digit
  • 在第 2 行,用户输入 abc
  • 在第 4 行,提示用户的输入错误: “abc is not digit”,具体的错误信息对用户要友好